<?php

/***
 * This software is intended for use with Oxdate Free Dating Software
 * http://www.oxdate.org/ and is licensed under The BSD license.
 * Full text of this license can be found at http://www.oxdate.org/license

 * =============================================================================
 * Copyright (c) 2016 Oxdate.org - All rights reserved.
 * =============================================================================

 * Redistribution and use in source and binary forms, with or without modification, are permitted provided that the
 * following conditions are met:

 * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.
 * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and
   the following disclaimer in the documentation and/or other materials provided with the distribution.
 * Neither the name of the Oxdate Foundation nor the names of its contributors may be used to endorse or promote products
   derived from this software without specific prior written permission.

 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES,
 * INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
 * AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
***/

if (
    OW::getPluginManager()->isPluginActive('oxdateios') ||
    OW::getPluginManager()->isPluginActive('oxandroid')
)

{
    $widgetService = BOL_ComponentAdminService::getInstance();
    $widget = $widgetService->addWidget('OXDATE_CMP_MobileExperience', false);

    try
    {
        $placeWidget = $widgetService->addWidgetToPlace($widget, BOL_ComponentAdminService::PLACE_INDEX);
        $widgetService->addWidgetToPosition($placeWidget, BOL_ComponentService::SECTION_RIGHT);
    }
    catch ( Exception $e )
    {
        OW::getLogger('oxdate.activate.widget_mobile_experience_index')->addEntry(json_encode($e));
    }

    try
    {
        $placeWidget = $widgetService->addWidgetToPlace($widget, BOL_ComponentAdminService::PLACE_DASHBOARD);
        $widgetService->addWidgetToPosition($placeWidget, BOL_ComponentService::SECTION_RIGHT);
    }
    catch ( Exception $e )
    {
        OW::getLogger('oxdate.activate.widget_mobile_experience_dashboard')->addEntry(json_encode($e));
    }

    try
    {
        $widgetService = BOL_MobileWidgetService::getInstance();
        $widget = $widgetService->addWidget('OXDATE_MCMP_PromoImageWidget', false);
        $placeWidget = $widgetService->addWidgetToPlace($widget, BOL_MobileWidgetService::PLACE_MOBILE_INDEX);
        $widgetService->addWidgetToPosition($placeWidget, BOL_MobileWidgetService::SECTION_MOBILE_MAIN, 0);
    }
    catch ( Exception $e )
    {
        OW::getLogger('oxdate.activate.widget_mobile_promo_image')->addEntry(json_encode($e));
    }
}
