<?php

/***
 * This software is intended for use with Oxdate Free Dating Software
 * http://www.oxdate.org/ and is licensed under The BSD license.
 * Full text of this license can be found at http://www.oxdate.org/license

 * =============================================================================
 * Copyright (c) 2016 Oxdate.org - All rights reserved.
 * =============================================================================

 * Redistribution and use in source and binary forms, with or without modification, are permitted provided that the
 * following conditions are met:

 * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.
 * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and
   the following disclaimer in the documentation and/or other materials provided with the distribution.
 * Neither the name of the Oxdate Foundation nor the names of its contributors may be used to endorse or promote products
   derived from this software without specific prior written permission.

 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES,
 * INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
 * AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
***/

$router = OW::getRouter();
$router->addRoute(new OW_Route('oxdate.settigns', 'oxdate/settings', 'OXDATE_CTRL_Admin', 'settings'));
$router->addRoute(new OW_Route('oxdate.uninstall', 'oxdate/uninstall', 'OXDATE_CTRL_Admin', 'uninstall'));


$router->removeRoute('base_join');
$router->addRoute(new OW_Route('base_join', 'join', 'OXDATE_CTRL_Join', 'index'));

function oxdate_remove_admin_bottom_link()
{
    if ( (bool) OW::getConfig()->getValue('oxdate', 'brand_removal') )
    {
        OW_ViewRenderer::getInstance()->assignVar('bottomPoweredByLink', '');
    }
    else
    {
        OW_ViewRenderer::getInstance()->assignVar('bottomPoweredByLink', '<a href="http://www.oxdate.org/" target="_blank" title="Powered by OxDate Dating Software"><img alt="Powered by Oxdate Dating Software" src="//static.oxdate.org/powered-by-oxdate.png" /></a>');
    }
}

OW::getEventManager()->bind(OW_EventManager::ON_BEFORE_DOCUMENT_RENDER, 'oxdate_remove_admin_bottom_link');


OXDATE_CLASS_EventHandler::getInstance()->init();
OXDATE_CLASS_EventHandler::getInstance()->genericInit();
OW::getEventManager()->bind('speedmatch.display_mutual_message', array(OXDATE_CLASS_EventHandler::getInstance(), 'displaySpeedmatchMutualMessage'));


function oxdate_after_plugin_init( OW_Event $event )
{
    if ( OW::getPluginManager()->getPlugin('oxdate')->getDto()->build == 7651 && OW::getConfig()->configExists('oxdate', 'update_gender_values') )
    {
        OXDATE_BOL_AccountTypeToGenderService::getInstance()->getInstance()->updateGenderValues();
        OW::getConfig()->saveConfig('oxdate', 'update_gender_values', false);
    }
}
OW::getEventManager()->bind(OW_EventManager::ON_PLUGINS_INIT, 'oxdate_after_plugin_init');

// temp fix for pcgallery plugin, should be deleted in 1.7.1
function oxdate_update_plugin_devkey()
{
    OW::getDbo()->query("UPDATE `" . OW_DB_PREFIX . "base_plugin` SET developerKey=:dk  WHERE `key`=:k", array(
        "dk" => "e547ebcf734341ec11911209d93a1054",
        "k" => "pcgallery"
    ));
}
OW::getEventManager()->bind(OW_EventManager::ON_AFTER_REQUEST_HANDLE, 'oxdate_update_plugin_devkey');

OW::getThemeManager()->addDecorator('user_big_list_item', 'oxdate');
function oxdate_add_members_only_exception( BASE_CLASS_EventCollector $event )
{
    $event->add(array('controller' => 'OXDATE_CTRL_Join', 'action' => 'index'));
    $event->add(array('controller' => 'OXDATE_CTRL_Join', 'action' => 'joinFormSubmit'));
}
OW::getEventManager()->bind('base.members_only_exceptions', 'oxdate_add_members_only_exception');

function oxdate_on_plugin_deactivate( OW_Event $event )
{
    $params = $event->getParams();

    if ( ($params['pluginKey'] == 'oxdateios' && !OW::getPluginManager()->isPluginActive('oxandroid')) ||
        ($params['pluginKey'] == 'oxandroid' && !OW::getPluginManager()->isPluginActive('oxdateios'))
    )
    {
        BOL_ComponentAdminService::getInstance()->deleteWidget('OXDATE_CMP_MobileExperience');
    }
}
OW::getEventManager()->bind(OW_EventManager::ON_BEFORE_PLUGIN_UNINSTALL, 'oxdate_on_plugin_deactivate');
OW::getEventManager()->bind(OW_EventManager::ON_BEFORE_PLUGIN_DEACTIVATE, 'oxdate_on_plugin_deactivate');

function oxdate_on_plugin_activate( OW_Event $event )
{
    $params = $event->getParams();

    if ( in_array($params['pluginKey'], array('oxdateios', 'oxandroid')) )
    {
        $widgetService = BOL_ComponentAdminService::getInstance();
        $widget = $widgetService->addWidget('OXDATE_CMP_MobileExperience', false);

        try
        {
            $placeWidget = $widgetService->addWidgetToPlace($widget, BOL_ComponentAdminService::PLACE_INDEX);
            $widgetService->addWidgetToPosition($placeWidget, BOL_ComponentService::SECTION_RIGHT);

            $placeWidget = $widgetService->addWidgetToPlace($widget, BOL_ComponentAdminService::PLACE_DASHBOARD);
            $widgetService->addWidgetToPosition($placeWidget, BOL_ComponentService::SECTION_RIGHT);
        }
        catch ( Exception $e )
        {
            OW::getLogger('oxdate.activate_widget_mobile_experience')->addEntry(json_encode($e));
        }
    }
}
OW::getEventManager()->bind(OW_EventManager::ON_AFTER_PLUGIN_INSTALL, 'oxdate_on_plugin_activate');
OW::getEventManager()->bind(OW_EventManager::ON_AFTER_PLUGIN_ACTIVATE, 'oxdate_on_plugin_activate');
