<?php

/***
 * This software is intended for use with Oxdate Free Dating Software
 * http://www.oxdate.org/ and is licensed under The BSD license.
 * Full text of this license can be found at http://www.oxdate.org/license

 * =============================================================================
 * Copyright (c) 2016 Oxdate.org - All rights reserved.
 * =============================================================================

 * Redistribution and use in source and binary forms, with or without modification, are permitted provided that the
 * following conditions are met:

 * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.
 * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and
   the following disclaimer in the documentation and/or other materials provided with the distribution.
 * Neither the name of the Oxdate Foundation nor the names of its contributors may be used to endorse or promote products
   derived from this software without specific prior written permission.

 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES,
 * INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
 * AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
***/

function pcgallery_get_content( BASE_CLASS_EventCollector $event )
{
    $params = $event->getParams();

    if ( $params['placeName'] != "profile" )
    {
        return;
    }

    if ( !PCGALLERY_CLASS_PhotoBridge::getInstance()->isActive() )
    {
        return;
    }
    
    $cmp = new PCGALLERY_CMP_Gallery($params['entityId']);
    $event->add($cmp->render());
}

OW::getEventManager()->bind('base.widget_panel.content.top', 'pcgallery_get_content');
OW::getEventManager()->bind('base.widget_panel_customize.content.top', 'pcgallery_get_content');

function pcgallery_class_get_instance( OW_Event $event )
{
    $params = $event->getParams();

    if ( $params['className'] != 'BASE_CMP_ProfileActionToolbar' )
    {
        return;
    }

    if ( !PCGALLERY_CLASS_PhotoBridge::getInstance()->isActive() )
    {
        return;
    }
    
    $arguments = $params['arguments'];
    $cmp = new PCGALLERY_CMP_ProfileActionToolbarMock($arguments[0]);
    $event->setData($cmp);

    return $cmp;
}
OW::getEventManager()->bind('class.get_instance', 'pcgallery_class_get_instance');

PCGALLERY_CLASS_PhotoBridge::getInstance()->init();

function pcgallery_after_plugin_activate( OW_Event $e )
{
    $params = $e->getParams();
    $pluginKey = $params['pluginKey'];

    if ( $pluginKey != 'photo' )
    {
        return;
    }
    
    $widgetService = BOL_ComponentAdminService::getInstance();
    $widgetService->deleteWidget('BASE_CMP_UserAvatarWidget');
}
OW::getEventManager()->bind(OW_EventManager::ON_AFTER_PLUGIN_ACTIVATE, "pcgallery_after_plugin_activate");

function pcgallery_before_plugin_deactivate( OW_Event $e )
{
    $params = $e->getParams();
    $pluginKey = $params['pluginKey'];

    if ( $pluginKey != 'photo' )
    {
        return;
    }
    
    $widgetService = BOL_ComponentAdminService::getInstance();

    $widget = $widgetService->addWidget('BASE_CMP_UserAvatarWidget', false);
    $widgetPlace = $widgetService->addWidgetToPlace($widget, BOL_ComponentService::PLACE_PROFILE);

    try 
    {
        $widgetService->addWidgetToPosition($widgetPlace, BOL_ComponentService::SECTION_LEFT, 0);
    }
    catch ( Exception $e ) {}
}
OW::getEventManager()->bind(OW_EventManager::ON_BEFORE_PLUGIN_DEACTIVATE, "pcgallery_before_plugin_deactivate");

// This event is triggered when album deleting, if an album is displayed on Profile Gallery then record about this will be cleared on default value
function pcgallery_before_photo_album_delete( OW_Event $event ) 
{
    $params = $event->getParams();    
    if( empty($params["id"]) ) // check the existence of  delete albums Id
    {
        return;
    }
    
    $eventAlbumFind = new OW_Event("photo.album_find", array("albumId" => $params["id"]));
    OW::getEventManager()->trigger($eventAlbumFind);
   
    $photoAlbum = $eventAlbumFind->getData(); //select info about delete albums
    $prefValue = BOL_PreferenceService::getInstance()->getPreferenceValue("pcgallery_album", $photoAlbum["userId"]);    
   
    if( $prefValue == $photoAlbum["id"] ) // if an deleting album is displayed on Profile Gallery
    {
       $pcgallerySourceInfo = BOL_PreferenceDao::getInstance()->findPreference("pcgallery_source");
       $pcgalleryAlbumInfo =  BOL_PreferenceDao::getInstance()->findPreference("pcgallery_album"); // select default values of preferences
       BOL_PreferenceService::getInstance()->savePreferenceValue("pcgallery_album", $pcgalleryAlbumInfo->defaultValue, $photoAlbum["userId"]);
       BOL_PreferenceService::getInstance()->savePreferenceValue("pcgallery_source", $pcgallerySourceInfo->defaultValue, $photoAlbum["userId"]); 
       // reset values of profile gallery on default 
    }     
}
OW::getEventManager()->bind('photo.before_album_delete', 'pcgallery_before_photo_album_delete');
